nxt

## Interface Blockchain

-     public interface Blockchain

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `DbIterator<? extends Block>` | `getAllBlocks()`
    `DbIterator<? extends Transaction>` | `getAllTransactions()`
    `Block` | `getBlock(long blockId)`
    `Block` | `getBlockAtHeight(int height)`
    `int` | `getBlockCount(long accountId)`
    `long` | `getBlockIdAtHeight(int height)`
    `java.util.List<java.lang.Long>` | `getBlockIdsAfter(long blockId, int limit)`
    `DbIterator<? extends Block>` | `getBlocks(java.sql.Connection con, java.sql.PreparedStatement pstmt)`
    `DbIterator<? extends Block>` | `getBlocks(int from, int to)`
    `DbIterator<? extends Block>` | `getBlocks(long accountId, int timestamp)`
    `DbIterator<? extends Block>` | `getBlocks(long accountId, int timestamp, int from, int to)`
    `java.util.List<? extends Block>` | `getBlocksAfter(long blockId, int limit)`
    `java.util.List<? extends Block>` | `getBlocksAfter(long blockId, java.util.List<java.lang.Long> blockList)`
    `Block` | `getECBlock(int timestamp)`
    `java.util.List<? extends Transaction>` | `getExpectedTransactions(Filter<Transaction> filter)`
    `int` | `getHeight()`
    `Block` | `getLastBlock()`
    `Block` | `getLastBlock(int timestamp)`
    `int` | `getLastBlockTimestamp()`
    `DbIterator<? extends Transaction>` | `getReferencingTransactions(long transactionId, int from, int to)`
    `Transaction` | `getTransaction(long transactionId)`
    `Transaction` | `getTransactionByFullHash(java.lang.String fullHash)`
    `int` | `getTransactionCount()`
    `DbIterator<? extends Transaction>` | `getTransactions(java.sql.Connection con, java.sql.PreparedStatement pstmt)`
    `DbIterator<? extends Transaction>` | `getTransactions(long accountId, byte type, byte subtype, int blockTimestamp, boolean includeExpiredPrunable)`
    `DbIterator<? extends Transaction>` | `getTransactions(long accountId, int numberOfConfirmations, byte type, byte subtype, int blockTimestamp, boolean withMessage, boolean phasedOnly, boolean nonPhasedOnly, int from, int to, boolean includeExpiredPrunable, boolean executedOnly)`
    `boolean` | `hasBlock(long blockId)`
    `boolean` | `hasTransaction(long transactionId)`
    `boolean` | `hasTransactionByFullHash(java.lang.String fullHash)`
    `void` | `readLock()`
    `void` | `readUnlock()`
    `void` | `updateLock()`
    `void` | `updateUnlock()`

- - ### Method Detail

    - #### readLock

          void readLock()

    - #### readUnlock

          void readUnlock()

    - #### updateLock

          void updateLock()

    - #### updateUnlock

          void updateUnlock()

    - #### getLastBlock

          Block getLastBlock()

    - #### getLastBlock

          Block getLastBlock(int timestamp)

    - #### getHeight

          int getHeight()

    - #### getLastBlockTimestamp

          int getLastBlockTimestamp()

    - #### getBlock

          Block getBlock(long blockId)

    - #### getBlockAtHeight

          Block getBlockAtHeight(int height)

    - #### hasBlock

          boolean hasBlock(long blockId)

    - #### getAllBlocks

          DbIterator<? extends Block> getAllBlocks()

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(int from,
                                                int to)

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(long accountId,
                                                int timestamp)

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(long accountId,
                                                int timestamp,
                                                int from,
                                                int to)

    - #### getBlockCount

          int getBlockCount(long accountId)

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(java.sql.Connection con,
                                                java.sql.PreparedStatement pstmt)

    - #### getBlockIdsAfter

          java.util.List<java.lang.Long> getBlockIdsAfter(long blockId,
                                                          int limit)

    - #### getBlocksAfter

          java.util.List<? extends Block> getBlocksAfter(long blockId,
                                                         int limit)

    - #### getBlocksAfter

          java.util.List<? extends Block> getBlocksAfter(long blockId,
                                                         java.util.List<java.lang.Long> blockList)

    - #### getBlockIdAtHeight

          long getBlockIdAtHeight(int height)

    - #### getECBlock

          Block getECBlock(int timestamp)

    - #### getTransaction

          Transaction getTransaction(long transactionId)

    - #### getTransactionByFullHash

          Transaction getTransactionByFullHash(java.lang.String fullHash)

    - #### hasTransaction

          boolean hasTransaction(long transactionId)

    - #### hasTransactionByFullHash

          boolean hasTransactionByFullHash(java.lang.String fullHash)

    - #### getTransactionCount

          int getTransactionCount()

    - #### getAllTransactions

          DbIterator<? extends Transaction> getAllTransactions()

    - #### getTransactions

          DbIterator<? extends Transaction> getTransactions(long accountId,
                                                            byte type,
                                                            byte subtype,
                                                            int blockTimestamp,
                                                            boolean includeExpiredPrunable)

    - #### getTransactions

          DbIterator<? extends Transaction> getTransactions(long accountId,
                                                            int numberOfConfirmations,
                                                            byte type,
                                                            byte subtype,
                                                            int blockTimestamp,
                                                            boolean withMessage,
                                                            boolean phasedOnly,
                                                            boolean nonPhasedOnly,
                                                            int from,
                                                            int to,
                                                            boolean includeExpiredPrunable,
                                                            boolean executedOnly)

    - #### getTransactions

          DbIterator<? extends Transaction> getTransactions(java.sql.Connection con,
                                                            java.sql.PreparedStatement pstmt)

    - #### getExpectedTransactions

          java.util.List<? extends Transaction> getExpectedTransactions(Filter<Transaction> filter)

    - #### getReferencingTransactions

          DbIterator<? extends Transaction> getReferencingTransactions(long transactionId,
                                                                       int from,
                                                                       int to)